## freealut 1.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,42 +24,6 @@
 
 FIND_PACKAGE(ConfigHelper)
 
-MACRO(CHECK_INCLUDE_FILE_DEFINE HEADER VAR)
-  CHECK_INCLUDE_FILE(${HEADER} HAVE_INCLUDE_FILE)
-  IF(HAVE_INCLUDE_FILE)
-    ADD_DEFINE("${VAR} 1")
-    SET(${VAR} ON CACHE INTERNAL "")
-  ENDIF(HAVE_INCLUDE_FILE)
-ENDMACRO(CHECK_INCLUDE_FILE_DEFINE ARG)
-
-MACRO(CHECK_FUNCTION_DEFINE HEADERS FUNC PARAM VAR)
-CHECK_C_SOURCE_COMPILES(
-"
-${HEADERS}
-int main(){
-${FUNC} ${PARAM};
-}
-" ${VAR})
-IF(${VAR})
-  ADD_DEFINE("${VAR} 1")
-ENDIF(${VAR})
-ENDMACRO(CHECK_FUNCTION_DEFINE HEADERS FUNC PARAM VAR)
-
-MACRO(CHECK_COMPILER_VISIBILITY VAR)
-SET(CMAKE_REQUIRED_FLAGS_BACK "${CMAKE_REQUIRED_FLAGS}")
-SET(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -fvisibility=hidden")
-CHECK_C_SOURCE_COMPILES(
-"void __attribute__((visibility(\"default\"))) test() {}
-int main(){}
-" ${VAR})
-SET(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS_BACK}")
-IF(${VAR})
-  ADD_DEFINITIONS(-fvisibility=hidden)
-  ADD_DEFINITIONS(-DHAVE_GCC_VISIBILITY)
-ENDIF(${VAR})
-ENDMACRO(CHECK_COMPILER_VISIBILITY VAR)
-
-
 SET(ALUT_SOURCES src/alutBufferData.c
                  src/alutCodec.c
                  src/alutError.c
@@ -67,6 +31,7 @@
                  src/alutInputStream.c
                  src/alutInternal.h
                  src/alutLoader.c
+                 src/alutOutputStream.c
                  src/alutUtil.c
                  src/alutVersion.c
                  src/alutWaveform.c)
@@ -92,12 +57,22 @@
 
 
 ADD_DEFINE(ALUT_BUILD_LIBRARY)
-ADD_DEFINITIONS(-D_XOPEN_SOURCE=500)
-ADD_DEFINITIONS(-D__NO_CTYPE)
+# We could possibly need struct timespec and random(), which are not ANSI.
+# Define to 500 if Single Unix conformance is wanted, 600 for sixth revision.
+ADD_DEFINE("_XOPEN_SOURCE 500")
+# We might need nanosleep, which is a POSIX IEEE Std 1003.1b-1993 feature.
+# Define to the POSIX version that should be used.
+ADD_DEFINE("_POSIX_C_SOURCE 199309")
+# Without __NO_CTYPE tolower and friends are macros which introduce a GLIBC 2.3
+# dependency. By defining this identifier we are currently backwards compatible
+# to GLIBC 2.1.3, which is a good thing. In addition, the macros lead to code
+# which triggers warnings with -Wunreachable-code.
+ADD_DEFINE("__NO_CTYPE 1")
+
 ADD_DEFINITIONS(-DHAVE_CONFIG_H)
 ADD_DEFINITIONS(-DNDEBUG)
 
-FIND_LIBRARY(OPENAL_LIB NAMES openal openal32 PATHS /usr/lib /usr/local/lib)
+FIND_LIBRARY(OPENAL_LIB NAMES openal openal32 PATHS /usr/lib /usr/local/lib ${OPENAL_LIB_DIR})
 IF(OPENAL_LIB MATCHES "NOTFOUND")
   MESSAGE(FATAL_ERROR "OpenAL not installed, cannot build alut - aborting.")
 ENDIF(OPENAL_LIB MATCHES "NOTFOUND")
@@ -106,26 +81,30 @@
  SET(ADD_LIBS ${ADD_LIBS} m)
 ENDIF(UNIX)
 
+SET(CMAKE_REQUIRED_INCLUDES ${OPENAL_INCLUDE_DIR})
 CHECK_INCLUDE_FILES("AL/alc.h;AL/al.h" AL_HEADERS)
 IF(NOT AL_HEADERS)
   MESSAGE(FATAL_ERROR "OpenAL header files not found - aborting.")
 ENDIF(NOT AL_HEADERS)
 
-CHECK_INCLUDE_FILE_DEFINE(unistd.h HAVE_UNISTD_H)
+IF(DEFINED OPENAL_INCLUDE_DIR)
+  INCLUDE_DIRECTORIES(${OPENAL_INCLUDE_DIR})
+ENDIF(DEFINED OPENAL_INCLUDE_DIR)
+
+FIND_PACKAGE(SleepFunction)
+
 CHECK_INCLUDE_FILE_DEFINE(stdint.h HAVE_STDINT_H)
-CHECK_INCLUDE_FILE_DEFINE(time.h HAVE_TIME_H)
+
 IF(WIN32)
   CHECK_INCLUDE_FILE_DEFINE(basetsd.h HAVE_BASETSD_H)
-  CHECK_INCLUDE_FILE_DEFINE(windows.h HAVE_WINDOWS_H)
 ENDIF(WIN32)
 
-
+# FindSleepFunction will check for unistd.h if time.h wasn't found
 IF(HAVE_TIME_H)
-  CHECK_FUNCTION_DEFINE("#include <time.h>" nanosleep "((struct timespec*)0, (struct timespec*)0)" HAVE_NANOSLEEP)
+  CHECK_INCLUDE_FILE_DEFINE(unistd.h HAVE_UNISTD_H)
 ENDIF(HAVE_TIME_H)
 
 IF(HAVE_UNISTD_H)
-  CHECK_FUNCTION_DEFINE("#include <unistd.h>" usleep "(0)" HAVE_USLEEP)
   CHECK_FUNCTION_DEFINE("
   #include <sys/types.h>
   #include <sys/stat.h>
@@ -140,11 +119,6 @@
   " _stat "(\"\", (struct _stat*)0)" HAVE__STAT)
 ENDIF(NOT HAVE_STAT)
 
-IF(HAVE_WINDOWS_H)
-  CHECK_FUNCTION_DEFINE("#include <windows.h>" Seep "(0)" HAVE_SLEEP)
-ENDIF(HAVE_WINDOWS_H)
-
-
 # compiler specific settings
 FIND_PACKAGE(CompilerAttribute)
 FIND_PACKAGE(CompilerVisibility)
@@ -158,18 +132,20 @@
 SET(CMAKE_MODULE_LINKER_FLAGS "${ADD_LDFLAGS} ${CMAKE_MODULE_LINKER_FLAGS}")
 
 IF(BUILD_STATIC)
-  #we can't create a static library with the same name
-  #as the shared one, so we copy it over after creation
-  ADD_LIBRARY(alut-static STATIC ${ALUT_SOURCES})
-  TARGET_LINK_LIBRARIES(alut-static ${OPENAL_LIB} ${ADD_LIBS})
-  ADD_CUSTOM_COMMAND(
-    TARGET alut-static
-    POST_BUILD
-    COMMAND ${CMAKE_COMMAND}
-    ARGS -E copy
-      ${CMAKE_BINARY_DIR}/${CMAKE_STATIC_LIBRARY_PREFIX}alut-static${CMAKE_STATIC_LIBRARY_SUFFIX}
-      ${CMAKE_BINARY_DIR}/${CMAKE_STATIC_LIBRARY_PREFIX}alut${CMAKE_STATIC_LIBRARY_SUFFIX})
-  INSTALL_FILES(/lib FILES ${CMAKE_STATIC_LIBRARY_PREFIX}alut${CMAKE_STATIC_LIBRARY_SUFFIX})
+  # we can't create a static library with the same name
+  # as the shared one, so we copy it over after creation
+  ADD_LIBRARY(alut_static STATIC ${ALUT_SOURCES})
+  TARGET_LINK_LIBRARIES(alut_static ${OPENAL_LIB} ${ADD_LIBS})
+  IF(NOT WIN32)
+    ADD_CUSTOM_COMMAND(
+      TARGET alut_static
+      POST_BUILD
+      COMMAND ${CMAKE_COMMAND}
+      ARGS -E copy
+        ${CMAKE_BINARY_DIR}/${CMAKE_STATIC_LIBRARY_PREFIX}alut_static${CMAKE_STATIC_LIBRARY_SUFFIX}
+        ${CMAKE_BINARY_DIR}/${CMAKE_STATIC_LIBRARY_PREFIX}alut${CMAKE_STATIC_LIBRARY_SUFFIX})
+    INSTALL_FILES(/lib FILES ${CMAKE_STATIC_LIBRARY_PREFIX}alut${CMAKE_STATIC_LIBRARY_SUFFIX})
+  ENDIF(NOT WIN32)
 ENDIF(BUILD_STATIC)
