=== debian/watch ===
version=4
opts=uversionmangle=s/_/./g \
https://github.com/vancegroup/freealut/releases .*/freealut_([\d+\._]+)@ARCHIVE_EXT@
